package com.fs.store.service;

import java.util.List;

import com.fs.common.core.domain.R;
import com.fs.store.domain.FsPrescribe;
import com.fs.store.param.*;
import com.fs.store.vo.FsPrescribeVO;

/**
 * 处方Service接口
 *
 * @author fs
 * @date 2022-03-15
 */
public interface IFsPrescribeService
{
    /**
     * 查询处方
     *
     * @param prescribeId 处方ID
     * @return 处方
     */
    public FsPrescribe selectFsPrescribeById(Long prescribeId);

    /**
     * 查询处方列表
     *
     * @param fsPrescribe 处方
     * @return 处方集合
     */
    public List<FsPrescribe> selectFsPrescribeList(FsPrescribe fsPrescribe);

    /**
     * 新增处方
     *
     * @param fsPrescribe 处方
     * @return 结果
     */
    public int insertFsPrescribe(FsPrescribe fsPrescribe);

    /**
     * 修改处方
     *
     * @param fsPrescribe 处方
     * @return 结果
     */
    public int updateFsPrescribe(FsPrescribe fsPrescribe);

    /**
     * 批量删除处方
     *
     * @param prescribeIds 需要删除的处方ID
     * @return 结果
     */
    public int deleteFsPrescribeByIds(Long[] prescribeIds);

    /**
     * 删除处方信息
     *
     * @param prescribeId 处方ID
     * @return 结果
     */
    public int deleteFsPrescribeById(Long prescribeId);

    R doPrescribe(long userId, FsPrescribeParam param);

    FsPrescribe selectFsPrescribeByRpId(String rp_id);

    List<FsPrescribeVO> selectFsPrescribeListQuery(FsPrescribeQueryParam param);

    List<FsPrescribeVO> selectFsPrescribeListVO(FsPrescribeVOParam fsPrescribe);

    FsPrescribe selectFsPrescribeByOrderId(Long id);

    String prescribeImg(Long prescribeId);

    String getFsPrescribeZyImg(PrescribeZyImgParam o);

    String getFsPrescribeXyImg(PrescribeXyImgParam o);

    /**
     * 生成处方图片和病历单
     */
    void generateDealImg();
}
